From 10c1ec6b8eaa9b38db76bad870dd69b45a5259a3 Mon Sep 17 00:00:00 2001
From: Pengpeng Dong <dongpengpeng@uniontech.com>
Date: Fri, 30 Jul 2021 14:47:37 +0800
Subject: [PATCH] user32: Fix the logical problem that the client window is a
 Unicode window and still goes A->W.

When the server is a Unicode server, the judgment of the client window type encoding is omitted.

Signed-off-by: Pengpeng Dong <dongpengpeng@uniontech.com>
Change-Id: Icbc2c995c6478f2629de75d10b1c52bd14507148
---
 dlls/user32/dde_server.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/dlls/user32/dde_server.c b/dlls/user32/dde_server.c
index e11c0c20d3b..34fbab4d2aa 100644
--- a/dlls/user32/dde_server.c
+++ b/dlls/user32/dde_server.c
@@ -819,7 +819,7 @@ static	WDML_QUEUE_STATE WDML_ServerHandleExecute(WDML_CONV* pConv, WDML_XACT* pX
 
 	if (ptr)
 	{
-            if (pConv->instance->unicode)  /* Unicode server, try to map A->W */
+            if (pConv->instance->unicode && !IsWindowUnicode( pConv->hwndClient ))  /* Unicode server, try to map A->W */
                 hDdeData = map_A_to_W( pConv->instance->instanceID, ptr, size );
             else if (!IsWindowUnicode( pConv->hwndClient )) /* ASCII server and client, try to map W->A */
                 hDdeData = map_W_to_A( pConv->instance->instanceID, ptr, size );
-- 
2.20.1

